/*************************************************************************/
/*                           PROPERTY OF THE                             */ 
/*                CONCURRENT SOFTWARE SYSTEMS LABORATORY                 */
/*************************************************************************/
/*************************************************************************/
/*                             Header File                               */
/*************************************************************************/
/*  The FACTOR #definition is used as a multiplier to establish the size */
/*  of the HashTable object.						 */	
/*************************************************************************/ 

#ifndef    HASHTABLE_H_
#define    HASHTABLE_H_
#include      <assert.h>
#include    <iostream.h>
#include       <stdio.h>
#include      <string.h>
#ifndef ENUM_BOOLEAN_
#define ENUM_BOOLEAN_
   enum bool { false, true };
#endif 


class HashTable 
   {
      
      public:
          	                 HashTable(int);
                                   ~HashTable();
       int                           hash(int*); // Hash function.
       int                           hash(long); // Hash from CheckSum
       int                            getSize();
       int&                     operator[](int);
       void                            Report(); 
       friend    
       ostream& operator<<(ostream&,HashTable&);
        
       private:

       int                             *HTarray;
       int                                 Size;
       int                      SymbolTableSize;
       int                             Occupied; 
       int                                 Free;
       int                 AddValues(int*, int);
       int            MultiplyValues(int*, int);
       int                 RadixHash(int*, int);
   };

       ostream& operator<<(ostream&, HashTable&);
       
#endif
/************************************************************************/
/*           Concurrent Software Systems Laboratory (c) 1995            */
/************************************************************************/
