#include "Interface.h"

Program         prog;
TempVar        *mod;
Node<Module*>  *mods;
Variable       *v;
Const          *c;
char            which = 'p';   // p: program
                               // a: automata without automatic tracking
                               // t: automata with automatic tracking
 
union mytype
{ char           *type1;
  int             type2;
  List<Module*>  *type3;
  List<TempVar*> *type4;
  ExprNode       *type5;
  AutoState      *type6;
  TempVar        *type7;
 };

#ifndef YYSTYPE
#define YYSTYPE mytype
#endif
# define Program 257
# define Mdl 258
# define FairnessType 259
# define Weak 260
# define Strong 261
# define FairPair 262
# define Of 263
# define Const 264
# define Automata 265
# define InitialState 266
# define FinalState 267
# define Tracking 268
# define Name 269
# define Digit 270
# define True 271
# define ConstName 272
# define Implies 273
# define Coma 274
# define Colin 275
# define Semicolin 276
# define Sequence 277
# define LSBRKT 278
# define RSBRKT 279
# define LCBRKT 280
# define RCBRKT 281
# define LBRKT 282
# define RBRKT 283
# define Notequal 284
# define Greatequal 285
# define Lessequal 286
# define Greater 287
# define Less 288
# define Equal 289
# define Add 290
# define Multiply 291
# define Divide 292
# define Modulo 293
# define Subtract 294
# define Assign 295
# define And 296
# define Or 297
# define Not 298
# define SUM 299
# define PRODUCT 300
# define OR 301

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256


int yywrap() {return(1);}
#include "lex.yy.c"
void yyerror(char *msg) 
{
printf("%d: %s at '%s'\n",yylineno, msg, yytext);
exit(0);
}

yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 33,
	276, 88,
	-2, 44,
-1, 50,
	296, 31,
	297, 33,
	-2, 27,
-1, 54,
	276, 86,
	278, 67,
	-2, 45,
-1, 71,
	278, 67,
	284, 45,
	289, 45,
	-2, 77,
-1, 83,
	278, 67,
	-2, 45,
-1, 124,
	296, 32,
	-2, 29,
-1, 125,
	297, 34,
	-2, 30,
-1, 126,
	276, 87,
	-2, 44,
-1, 154,
	278, 67,
	284, 45,
	289, 45,
	-2, 80,
	};
# define YYNPROD 106
# define YYLAST 357
yytabelem yyact[]={

   111,   112,    12,    41,    56,    26,    12,    85,    84,    48,
    97,    98,    99,   151,   186,    59,    12,    41,    56,    26,
    91,    92,    93,    94,    95,    96,    89,    61,   116,    59,
    90,    51,    65,    66,    67,    89,    76,   121,    36,    90,
   182,    61,    48,    29,   134,    51,    65,    66,    67,    12,
    41,    56,    26,   104,   152,   101,   172,    42,   105,   127,
    45,   185,    59,    12,    41,    56,    26,    19,   162,   149,
    26,   148,   141,   108,    61,    81,    59,    75,    51,    65,
    66,    67,    18,    12,    41,    56,    26,    74,    61,    24,
   179,   178,    51,    65,    66,    67,    59,    12,    41,   161,
    26,   123,    35,   147,    20,   173,   171,   165,    61,   164,
    59,   150,   106,    65,    66,    67,    43,    79,    41,     6,
    38,    39,    61,     9,    12,    11,    15,    65,    66,    67,
    12,     6,    12,    41,    27,     9,     2,    11,   107,   166,
    86,   143,    12,    64,     3,    22,    23,    83,   118,   144,
     7,   157,     7,   142,    17,   109,    68,   153,    70,    62,
    50,    55,     8,    46,     8,    21,    32,    33,    58,    37,
     5,    31,    13,    69,   145,    16,   113,   110,    14,    87,
    49,    78,    54,    71,    47,    25,    40,    57,    28,    10,
    44,    32,    34,    73,     4,     1,   158,   119,    52,    53,
   156,    30,   103,    60,    88,    63,     0,     0,     0,     0,
     0,     0,    82,     0,    80,    77,     0,     0,     0,     0,
    72,     0,     0,   120,     0,     0,    54,   122,     0,     0,
   102,     0,     0,   115,   126,     0,     0,     0,     0,     0,
     0,     0,   117,     0,   100,   124,   125,     0,     0,   136,
   128,   136,     0,     0,    71,   140,     0,     0,     0,   114,
   138,   135,     0,   137,     0,   139,   131,   132,   133,   146,
     0,   154,     0,     0,     0,   159,     0,   129,   130,     0,
     0,     0,     0,     0,   160,     0,     0,     0,     0,   167,
     0,    72,     0,     0,   120,     0,     0,   163,   122,   168,
   136,     0,     0,     0,     0,     0,     0,     0,   155,     0,
     0,     0,   170,     0,   177,   176,     0,     0,   175,   154,
   183,   159,   146,   120,     0,   181,   114,   122,   184,   180,
   160,     0,     0,     0,     0,     0,   169,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   174,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   155 };
yytabelem yypact[]={

  -121,-10000000,  -127,-10000000,  -139,-10000000,  -145,  -196,  -171,  -115,
  -187,  -202,-10000000,-10000000,  -132,-10000000,-10000000,  -252,  -145,  -145,
-10000000,  -173,-10000000,-10000000,-10000000,  -257,-10000000,  -149,-10000000,  -152,
  -222,-10000000,  -158,-10000000,  -220,  -206,  -152,  -189,-10000000,-10000000,
  -199,-10000000,  -259,  -145,-10000000,-10000000,-10000000,  -156,  -115,  -201,
-10000000,  -186,  -288,  -290,  -123,  -264,-10000000,  -281,-10000000,  -206,
  -227,  -172,  -231,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
  -162,  -125,-10000000,  -203,  -267,-10000000,  -152,-10000000,  -253,  -263,
  -174,-10000000,-10000000,  -125,  -186,  -186,  -145,  -219,  -172,  -172,
  -172,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -172,  -172,  -172,
  -239,  -145,-10000000,  -137,-10000000,-10000000,  -206,  -145,-10000000,-10000000,
  -204,  -149,  -152,-10000000,  -170,  -205,-10000000,-10000000,  -207,  -163,
  -282,  -228,-10000000,  -206,-10000000,-10000000,-10000000,  -137,  -255,  -281,
  -281,-10000000,-10000000,-10000000,-10000000,  -176,  -125,-10000000,-10000000,  -208,
-10000000,  -267,-10000000,  -165,-10000000,  -167,  -124,  -149,-10000000,-10000000,
  -263,  -206,  -145,  -168,  -125,-10000000,  -223,-10000000,  -169,-10000000,
-10000000,  -206,-10000000,-10000000,  -149,  -152,  -145,  -184,-10000000,-10000000,
  -185,  -206,-10000000,  -137,  -243,-10000000,-10000000,-10000000,  -149,  -263,
  -215,-10000000,-10000000,-10000000,  -269,-10000000,-10000000 };
yytabelem yypgo[]={

     0,   147,   173,   205,   156,   204,   203,   165,   202,   171,
   201,   200,   151,   161,   187,   168,   160,   199,   198,   184,
   143,   148,   197,   158,   157,   141,   196,   159,   195,   194,
   172,   170,   192,   190,   189,   181,   163,   180,   179,   178,
   155,   177,   153,   149,   176,   174 };
yytabelem yyr1[]={

     0,    28,    28,    28,    29,    29,    31,    31,    32,    31,
    31,    31,    31,     1,     2,     4,    10,    10,     9,     9,
    33,    33,    35,    35,    36,    36,    36,    19,    19,    19,
    19,    18,    18,    17,    17,    16,    16,    16,     5,     5,
     5,     5,     5,     5,    27,    27,    13,    13,    13,    14,
    14,    14,    14,    15,    15,    15,    15,    15,    15,    15,
     6,     6,     6,     8,     8,     3,     3,    38,    20,    11,
    11,    12,    12,    26,    26,     7,     7,    23,    23,    24,
    24,    24,    21,    21,    22,    22,    37,    37,    34,    39,
    30,    25,    25,    40,    40,    41,    41,    41,    41,    41,
    42,    42,    43,    43,    45,    44 };
yytabelem yyr2[]={

     0,     4,     8,     4,     4,     2,    11,    15,     1,     8,
    15,     4,    11,     3,     3,     3,     1,     3,     3,     7,
     6,     2,     4,     0,     9,    15,     4,     3,     5,     7,
     7,     3,     7,     3,     7,     7,     3,     3,     3,     3,
     3,     3,     3,     3,     7,     3,     7,     7,     3,     7,
     7,     7,     3,     7,    13,     5,     7,     7,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     1,    11,     1,
     3,     3,     7,     3,     3,     3,     3,     3,     3,     1,
     3,     3,     3,     7,     7,    13,     3,     7,     7,     1,
    10,     3,     3,     0,     6,     2,     4,     3,     5,     2,
     3,     7,     2,     6,     7,    11 };
yytabelem yychk[]={

-10000000,   -28,   257,   265,   -29,   -31,   258,    -1,   -27,   262,
   -34,   264,   269,   -30,   -39,   265,   -31,    -1,   278,   263,
   275,    -7,   260,   261,   276,    -2,   272,   266,   -30,   295,
   -10,    -9,    -1,    -1,   -32,   275,   295,   -25,   269,   270,
    -4,   270,   279,   274,   -33,   280,   -36,   -19,   262,   -37,
   -16,   298,   -18,   -17,    -1,   -13,   271,   -14,   -15,   282,
    -6,   294,   -27,    -3,   -20,   299,   300,   301,    -4,    -2,
   -23,    -1,   -19,    -4,   276,   276,   295,    -9,   -35,   273,
    -7,   276,   -16,    -1,   296,   297,   263,   -38,    -5,   290,
   294,   284,   285,   286,   287,   288,   289,   291,   292,   293,
   -19,   282,   -15,    -8,   284,   289,   274,   263,   276,   -40,
   -41,   267,   268,   -44,   -19,    -4,   281,   -36,   -21,   -22,
   -20,   300,    -1,   275,   -16,   -16,    -1,   278,   -13,   -14,
   -14,   -15,   -15,   -15,   283,   -27,    -1,   -27,    -4,   -23,
    -1,   276,   -42,   -25,   -43,   -45,    -4,   273,   276,   276,
   274,   295,   282,   -24,    -1,   -19,   -11,   -12,   -26,    -1,
    -4,   275,   276,   -40,   274,   274,   263,   -25,   -21,   -19,
   -27,   274,   279,   274,   -19,   -42,   -43,    -1,   275,   275,
   -24,   -12,   283,   -25,   -21,   276,   283 };
yytabelem yydef[]={

     0,    -2,     0,    89,     1,     5,     0,    45,     0,     0,
     0,     0,    13,     3,     0,    89,     4,     0,    16,     0,
     8,     0,    75,    76,    11,     0,    14,     0,     2,     0,
     0,    17,    18,    -2,     0,     0,     0,     0,    91,    92,
     0,    15,     0,     0,     9,    23,    21,     0,     0,     0,
    -2,     0,     0,     0,    -2,    36,    37,    48,    52,     0,
     0,     0,     0,    58,    59,    60,    61,    62,    65,    66,
     0,    -2,    78,     0,    93,     6,     0,    19,     0,     0,
     0,    26,    28,    -2,     0,     0,     0,     0,     0,     0,
     0,    38,    39,    40,    41,    42,    43,     0,     0,     0,
     0,     0,    55,     0,    63,    64,     0,     0,    12,    90,
     0,    95,    97,    99,     0,     0,    20,    22,     0,    82,
     0,     0,    67,    79,    -2,    -2,    -2,    69,    35,    46,
    47,    49,    50,    51,    53,     0,    45,    56,    57,     0,
    44,    93,    96,   100,    98,   102,     0,     0,     7,    24,
     0,     0,     0,     0,    -2,    81,     0,    70,    71,    73,
    74,     0,    10,    94,     0,     0,     0,     0,    83,    84,
     0,    79,    68,     0,     0,   101,   103,   104,     0,     0,
     0,    72,    54,   105,     0,    25,    85 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	1	/* allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"Program",	257,
	"Mdl",	258,
	"FairnessType",	259,
	"Weak",	260,
	"Strong",	261,
	"FairPair",	262,
	"Of",	263,
	"Const",	264,
	"Automata",	265,
	"InitialState",	266,
	"FinalState",	267,
	"Tracking",	268,
	"Name",	269,
	"Digit",	270,
	"True",	271,
	"ConstName",	272,
	"Implies",	273,
	"Coma",	274,
	"Colin",	275,
	"Semicolin",	276,
	"Sequence",	277,
	"LSBRKT",	278,
	"RSBRKT",	279,
	"LCBRKT",	280,
	"RCBRKT",	281,
	"LBRKT",	282,
	"RBRKT",	283,
	"Notequal",	284,
	"Greatequal",	285,
	"Lessequal",	286,
	"Greater",	287,
	"Less",	288,
	"Equal",	289,
	"Add",	290,
	"Multiply",	291,
	"Divide",	292,
	"Modulo",	293,
	"Subtract",	294,
	"Assign",	295,
	"And",	296,
	"Or",	297,
	"Not",	298,
	"SUM",	299,
	"PRODUCT",	300,
	"OR",	301,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"program : Program commands",
	"program : Program commands Automata automata",
	"program : Automata automata",
	"commands : commands command",
	"commands : command",
	"command : Mdl name Assign value Semicolin",
	"command : name LSBRKT some_module_names RSBRKT Assign value Semicolin",
	"command : naked_temp_var Colin",
	"command : naked_temp_var Colin module",
	"command : FairPair fair_type Colin fair_cond Coma fair_cond Semicolin",
	"command : temp_var_declaration Semicolin",
	"command : Const const Assign value Semicolin",
	"name : Name",
	"const : ConstName",
	"value : Digit",
	"some_module_names : /* empty */",
	"some_module_names : module_names",
	"module_names : name",
	"module_names : name Coma module_names",
	"module : LCBRKT module_commands RCBRKT",
	"module : module_command",
	"module_commands : module_commands module_command",
	"module_commands : /* empty */",
	"module_command : condition_leaf Implies actions Semicolin",
	"module_command : FairPair fair_type Colin mod_fair_cond Coma mod_fair_cond Semicolin",
	"module_command : mod_temp_var_declaration Semicolin",
	"condition_leaf : condition",
	"condition_leaf : Not condition",
	"condition_leaf : a_condition_leaf And condition",
	"condition_leaf : o_condition_leaf Or condition",
	"a_condition_leaf : condition",
	"a_condition_leaf : a_condition_leaf And condition",
	"o_condition_leaf : condition",
	"o_condition_leaf : o_condition_leaf Or condition",
	"condition : expression relation expression",
	"condition : expression",
	"condition : True",
	"relation : Notequal",
	"relation : Greatequal",
	"relation : Lessequal",
	"relation : Greater",
	"relation : Less",
	"relation : Equal",
	"naked_temp_var : name Of name",
	"naked_temp_var : name",
	"expression : expression Add term",
	"expression : expression Subtract term",
	"expression : term",
	"term : term Multiply factor",
	"term : term Divide factor",
	"term : term Modulo factor",
	"term : factor",
	"factor : LBRKT condition_leaf RBRKT",
	"factor : function_sym LBRKT naked_temp_var Colin condition_leaf RBRKT",
	"factor : Subtract factor",
	"factor : naked_temp_var equality_test naked_temp_var",
	"factor : naked_temp_var equality_test value",
	"factor : const_or_value",
	"factor : old_variable",
	"function_sym : SUM",
	"function_sym : PRODUCT",
	"function_sym : OR",
	"equality_test : Notequal",
	"equality_test : Equal",
	"const_or_value : value",
	"const_or_value : const",
	"old_variable : name",
	"old_variable : name LSBRKT rest_of_variable RSBRKT",
	"rest_of_variable : /* empty */",
	"rest_of_variable : indeces",
	"indeces : name_or_value",
	"indeces : name_or_value Coma indeces",
	"name_or_value : name",
	"name_or_value : value",
	"fair_type : Weak",
	"fair_type : Strong",
	"fair_cond : name",
	"fair_cond : condition_leaf",
	"mod_fair_cond : /* empty */",
	"mod_fair_cond : name",
	"mod_fair_cond : condition_leaf",
	"actions : action",
	"actions : action Coma actions",
	"action : old_variable Assign condition_leaf",
	"action : PRODUCT LBRKT naked_temp_var Colin actions RBRKT",
	"mod_temp_var_declaration : name",
	"mod_temp_var_declaration : name Of name",
	"temp_var_declaration : name Of name",
	"automata : /* empty */",
	"automata : InitialState a_state Semicolin a_commands",
	"a_state : Name",
	"a_state : Digit",
	"a_commands : /* empty */",
	"a_commands : a_command Semicolin a_commands",
	"a_command : FinalState",
	"a_command : FinalState a_fin_states",
	"a_command : Tracking",
	"a_command : Tracking a_trackings",
	"a_command : a_transition",
	"a_fin_states : a_state",
	"a_fin_states : a_state Coma a_fin_states",
	"a_trackings : a_tracking",
	"a_trackings : a_tracking Coma a_trackings",
	"a_tracking : value Of name",
	"a_transition : condition_leaf Implies a_state Colin a_state",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 6:{ if(prog.FindModule(yypvt[-3].type1)!=NULL)
			        yyerror("#1: Redefining a module name"); 
			      prog.AddModule(yypvt[-3].type1,yypvt[-1].type2); } break;
case 7:{ if(prog.FindVariable(yypvt[-6].type1)!=NULL)
			        yyerror("#2: Redefining a variable name"); 
			      prog.AddVariable(new Variable(yypvt[-6].type1,yypvt[-4].type3,yypvt[-1].type2));  } break;
case 8:{ mod = yypvt[-1].type7; } break;
case 10:{ prog.AddFairPair(yypvt[-5].type2,yypvt[-3].type5,yypvt[-1].type5); } break;
case 12:{ if(prog.FindConst(yypvt[-3].type1)!=NULL)
			        yyerror("#2b: Redefining a const name"); 
			      prog.AddConst(yypvt[-3].type1,yypvt[-1].type2);  } break;
case 13:{ yyval.type1 = new char[strlen(yytext) +1]; strcpy(yyval.type1,yytext);} break;
case 14:{ yyval.type1 = new char[strlen(yytext) +1]; strcpy(yyval.type1,yytext);} break;
case 15:{ yyval.type2 = atoi(yytext);} break;
case 16:{ yyval.type3 = new List<Module *>; } break;
case 17:{ yyval.type3 = yypvt[-0].type3; } break;
case 18:{ Module *md = prog.FindModule(yypvt[-0].type1);
				delete [] yypvt[-0].type1;
				if(md == NULL)
				  yyerror("#6: Undefined module name"); 
				yyval.type3 = new List<Module*>;
				yyval.type3->Insert(md); } break;
case 19:{ Module *md = prog.FindModule(yypvt[-2].type1);
				delete [] yypvt[-2].type1;
				if(md == NULL)
				  yyerror("#7: Undefined module name"); 
				(yypvt[-0].type3)->Insert(md);
				yyval.type3 = yypvt[-0].type3; } break;
case 24:{ prog.AddTransition(new Transition(mod,
				 new ExprNode(',', yypvt[-3].type5, yypvt[-1].type5))); } break;
case 25:{ prog.AddFairPair(yypvt[-5].type2,yypvt[-3].type5,yypvt[-1].type5); } break;
case 27:{ yyval.type5 = yypvt[-0].type5;} break;
case 28:{ yyval.type5 = new ExprNode('!',(yypvt[-0].type5));} break;
case 29:{ yyval.type5 = new ExprNode('&', (yypvt[-2].type5), (yypvt[-0].type5));} break;
case 30:{ yyval.type5 = new ExprNode('|', (yypvt[-2].type5), (yypvt[-0].type5));} break;
case 31:{ yyval.type5 = yypvt[-0].type5;} break;
case 32:{ yyval.type5 = new ExprNode('&', (yypvt[-2].type5), (yypvt[-0].type5));} break;
case 33:{ yyval.type5 = yypvt[-0].type5;} break;
case 34:{ yyval.type5 = new ExprNode('|', (yypvt[-2].type5), (yypvt[-0].type5));} break;
case 35:{ yyval.type5 = new ExprNode(yypvt[-1].type2, (yypvt[-2].type5), (yypvt[-0].type5));} break;
case 36:{ yyval.type5 = yypvt[-0].type5;} break;
case 37:{ yyval.type5 = new ExprNode(1);} break;
case 38:{ yyval.type2 = 'N';} break;
case 39:{ yyval.type2 = 'G';} break;
case 40:{ yyval.type2 = 'L';} break;
case 41:{ yyval.type2 = 'g';} break;
case 42:{ yyval.type2 = 'l';} break;
case 43:{ yyval.type2 = 'E';} break;
case 44:{ Module *mp = prog.FindModule(yypvt[-0].type1);
		  	delete [] yypvt[-0].type1;
		  	if(mp == NULL) yyerror("#12: Undefined module name");
                        if((yyval.type7 = prog.AddTempVar(mp,yypvt[-2].type1))==NULL)
				yyerror("#13: Redefining an index variable");
		      } break;
case 45:{ if((yyval.type7 = prog.AddTempVar(yypvt[-0].type1))==NULL)
				yyerror("#14: Undefined index variable"); } break;
case 46:{ yyval.type5 = new ExprNode('+', yypvt[-2].type5, yypvt[-0].type5); } break;
case 47:{ yyval.type5 = new ExprNode('-', yypvt[-2].type5, yypvt[-0].type5); } break;
case 48:{ yyval.type5 = yypvt[-0].type5;} break;
case 49:{ yyval.type5 = new ExprNode('*', yypvt[-2].type5, yypvt[-0].type5); } break;
case 50:{ yyval.type5 = new ExprNode('/', yypvt[-2].type5, yypvt[-0].type5); } break;
case 51:{ yyval.type5 = new ExprNode('%', yypvt[-2].type5, yypvt[-0].type5); } break;
case 52:{ yyval.type5 = yypvt[-0].type5;} break;
case 53:{ yyval.type5 = yypvt[-1].type5;} break;
case 54:{ yyval.type5 = new ExprNode(yypvt[-5].type2, yypvt[-3].type7, yypvt[-1].type5); } break;
case 55:{ yyval.type5 = new ExprNode('M', yypvt[-0].type5); } break;
case 56:{ if(yypvt[-2].type7->module != yypvt[-0].type7->module) 
		  yyerror("#16: Attempt to compare indeces of different type");
		  yyval.type5 = new ExprNode(yypvt[-1].type2, yypvt[-2].type7, yypvt[-0].type7); } break;
case 57:{ if(which == 'p')   yyerror("#35: Attempt to break symmetry");
		  if(yypvt[-0].type2<0 || yypvt[-0].type2>=yypvt[-2].type7->module->num_of_instances) 
			yyval.type5 = new ExprNode(0);
		  else { TempVar *t = new TempVar(yypvt[-2].type7->module, yypvt[-0].type2);
 		  	 if(which == 't')   prog.AddTracked(t);
		 	 yyval.type5 = new ExprNode(yypvt[-1].type2, yypvt[-2].type7, t);
		       }
		} break;
case 58:{ yyval.type5 = new ExprNode(yypvt[-0].type2);} break;
case 59:{ yyval.type5 = yypvt[-0].type5; } break;
case 60:{ yyval.type2 = 'S' ;} break;
case 61:{ yyval.type2 = 'P' ;} break;
case 62:{ yyval.type2 = 'O' ;} break;
case 63:{ yyval.type2 = 'n';} break;
case 64:{ yyval.type2 = 'e';} break;
case 65:{ yyval.type2 = yypvt[-0].type2;} break;
case 66:{ c = prog.FindConst(yypvt[-0].type1);
		  delete [] yypvt[-0].type1;
		  if(c == NULL) yyerror("#17b: Const name is undefined");
		  yyval.type2 = c->value; } break;
case 67:{ v = prog.FindVariable(yypvt[-0].type1);
		  if(v == NULL) yyerror("#17: Variable name is undefined");
		  mods = v->GetHead(); } break;
case 68:{ yyval.type5 = new ExprNode(v,yypvt[-1].type4); 
		  delete [] yypvt[-4].type1; } break;
case 69:{ if(mods!=NULL) yyerror("#18: Missing indeces");
				   yyval.type4 = new List<TempVar*>; } break;
case 70:{ yyval.type4 = yypvt[-0].type4; } break;
case 71:{ if(mods!=NULL) yyerror("#19: Missing indeces");
		  yyval.type4 = new List<TempVar*>;
		  yyval.type4->Insert(yypvt[-0].type7); } break;
case 72:{ yypvt[-0].type4->Insert(yypvt[-2].type7);
		  yyval.type4 = yypvt[-0].type4; } break;
case 73:{ if(mods==NULL)     yyerror("#20: Too many indeces");
		  if((yyval.type7 = prog.AddTempVar(mods->data,yypvt[-0].type1))==NULL)
			yyerror("#22: Redefining an index variable"); 
		  mods = mods->Next;
		} break;
case 74:{ if(which == 'p')   yyerror("#23: Attempt to break symmetry");
		  if(mods==NULL)     yyerror("#24: Too many indeces");
		  if(yypvt[-0].type2<0 || yypvt[-0].type2>=mods->data->num_of_instances)
				     yyerror("#26: Index is out of range");
		  yyval.type7 = new TempVar(mods->data, yypvt[-0].type2);
 		  if(which == 't')   prog.AddTracked(yyval.type7);
		  mods = mods->Next;
		} break;
case 75:{ yyval.type2 = 'w';} break;
case 76:{ yyval.type2 = 's';} break;
case 77:{ Module *md = prog.FindModule(yypvt[-0].type1);
			 if(md == NULL) yyerror("#27: Undefined module name");
			 yyval.type5 = new ExprNode(md);
			 delete [] yypvt[-0].type1; } break;
case 78:{ yyval.type5 = yypvt[-0].type5; } break;
case 79:{ yyval.type5 = new ExprNode(mod->module); } break;
case 80:{ Module *mp = prog.FindModule(yypvt[-0].type1); 
			 if(mp == NULL) yyerror("#28: Undefined module name");
			 yyval.type5 = new ExprNode(mp);
			 delete [] yypvt[-0].type1; } break;
case 81:{ yyval.type5 = yypvt[-0].type5; } break;
case 82:{ yyval.type5 = yypvt[-0].type5; } break;
case 83:{ yyval.type5 = new ExprNode(',', (yypvt[-2].type5), (yypvt[-0].type5)); } break;
case 84:{ yyval.type5 = new ExprNode('=', yypvt[-2].type5, yypvt[-0].type5); } break;
case 85:{ yyval.type5 = new ExprNode('P', yypvt[-3].type7, yypvt[-1].type5); } break;
case 86:{ if(prog.AddTempVar(mod->module,yypvt[-0].type1)==NULL)
			yyerror("#8: Redefining an index variable"); 
		} break;
case 87:{ Module *md = prog.FindModule(yypvt[-0].type1);
		  delete [] yypvt[-0].type1;
		  if(md == NULL) yyerror("#9: Undefined module name"); 
		  if(prog.AddTempVar(md,yypvt[-2].type1)==NULL)
			yyerror("#10: Redefining an index variable"); 
		} break;
case 88:{ Module *md = prog.FindModule(yypvt[-0].type1);
		  delete [] yypvt[-0].type1;
		  if(md == NULL) yyerror("#4: Undefined module name"); 
		  if(prog.AddTempVar(md,yypvt[-2].type1)==NULL)
			yyerror("#5: Redefining an index variable"); 
		} break;
case 89:{ which = 't'; } break;
case 91:{ yyval.type6 = prog.AddAutoState(yytext); } break;
case 92:{ yyval.type6 = prog.AddAutoState(yytext); } break;
case 97:{ which = 'a'; } break;
case 98:{ which = 'a'; } break;
case 100:{ yypvt[-0].type6->SetFinal(); } break;
case 101:{ yypvt[-2].type6->SetFinal(); } break;
case 104:{ Module *md = prog.FindModule(yypvt[-0].type1);
		  delete [] yypvt[-0].type1;
		  if(md == NULL) yyerror("#30: Undefined module name");  
 		  if(yypvt[-2].type2<0 || yypvt[-2].type2>=md->num_of_instances)
			 yyerror("#31: Index is out of range");
		  prog.AddTracked(md, yypvt[-2].type2);
		} break;
case 105:{  if(!(yypvt[-4].type5->GetTempVars()->isEmpty()))
 		    yyerror("#32: Condition should not contain unbound index");
		   AutoTransition *a = new AutoTransition;  
		   a->condition = yypvt[-4].type5;
	           a->departure = yypvt[-2].type6;
                   a->destination = yypvt[-0].type6;
                   prog.AddAutoTransition(a);
	      	} break;
	}
	goto yystack;		/* reset registers in driver code */
}

